#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "random.h"

#define TRUE 1
#define FALSE 0

long  alpha_size = 4; 
static char code[5] = "actg";

/**********************************************************************/
void  print_instance
( 
  long  m,
  long  n,
  long  seed 
)
{
  long       i, j;

  init_rand( seed );

  for( i = 0;  i < m;  i++ )
  {
    printf("< ");
    for( j = 0;  j < n;  j++ ) 
    {
      printf( "%c", code[unif_rand(alpha_size)] ); ;
    }

    printf( " , ");
    for( j = 0;  j < n;  j++ ) 
    {
      printf( "%c", code[unif_rand(alpha_size)] ); ;
    }

    printf(" >\n");

  }
}

/***********************************************************************/

int  main(
  int  argc, 
  char**  argv )
{
  long  i;
  long  m       = 10;
  long  n       = 10;
  long  seed          = 1;
  long  unrecognized_param = FALSE;

  for( i = 1; i < argc; i++)
  {
    if( strncmp(argv[i], "-m", strlen("-m")) == 0 )
    {
      m = atol(argv[++i]);
    }
    else if( strncmp(argv[i], "-n", strlen("-n")) == 0 )
    {
      n = atol(argv[++i]);
    }
    else if( strncmp(argv[i], "-seed", strlen("-seed")) == 0 )
    {
      seed = atol(argv[++i]);
    }
    else 
    {
      unrecognized_param = TRUE;
    }
  }

  if( unrecognized_param )
  {
    fprintf( stderr, "Usage: %s ", argv[0] );
    fprintf( stderr, "[-m N] " );
    fprintf( stderr, "[-n N] " );
    fprintf( stderr, "[-seed N]\n" );
    return  -1;
  }

  print_instance( m, n, seed );

  return 0;
}

/*********************************************************************** 
***********************************************************************/
